# frozen_string_literal: true

class Hermes::Api::Dmo::HousingRequestInitializersController < Hermes::Api::Dmo::ApplicationController
  class << self
    def mutate_params
      {
      }
    end 

    def acceptable_params
      {
        unique_number: {type: 'String'},
        pin_code_created_at: {type: 'DateTime'},
        email: {type: 'String'},
        done: {type: 'Boolean'},
      }.merge(self.mutate_params).merge(super)
    end 

    def valid_operators
      %w[$in $nin $ne $gt $gte $lt $lte $eq $regex $all]
    end

    def regex_params
      {}
    end 
  end

  def index
    acceptable_params *self.class.acceptable_params.keys
    valid_operators *self.class.valid_operators

    aggregation = if !(['superadministrateur', 'collaborateur offre logement'] & current_user_roles).empty?
                    index_aggregation(no_acl: true)
                  else
                    index_aggregation
                  end

    paginate(
      aggregation,
      each_serializer: @serializer,
    )

  end
end