raise 'You need to load this script througth a require' unless __FILE__
# Replace following variables if need
FILE_TYPE = 'csv'
FILE_PATH = "."

def file_log(file, line)
  file << line
  puts line.join(', ')
end 

def run_script(skip)
  start_time = Time.now
  formated_t = start_time.strftime('%Y-%m-%d-%H:%M')
  puts "Start script at #{start_time}"
  file_name   = "#{HERMES_CONFIG['environment']}-#{formated_t}-#{__FILE__.split('/').last.gsub('.rb', ".#{FILE_TYPE}")}"
  file_class  = FILE_TYPE == 'csv' ? CSV : File
  file        = file_class.open("#{FILE_PATH}/#{file_name}", 'ab')
  ##############################################################################
  ##################################__SCRIPT__##################################
  # write the content of the script bellow
  file << [
    "housing offer_id",
    "external_ref",
    "als_id",
    "old_offer_status",
    "old_lessor_status",
    "offer_status",
    "lessor_status",
    "action",
  ]
mapping = {
            "ACO"=>{
              offer_s: "EN ATTENTE COMMERCIALISATION",
              lessor_s: "EN ATTENTE PUBLICATION"},
            "QUA"=>{
              offer_s: "EN ATTENTE COMMERCIALISATION",
              lessor_s: "EN ATTENTE PUBLICATION"},
            "COA"=>{
              offer_s: "LOGEMENT PUBLIE",
              lessor_s: "PUBLIE"},
            "COS"=>{
              offer_s: "COMMERCIALISE SANS PUBLICATION",
              lessor_s: "PUBLIE"},
            "ARC"=>{
              offer_s: "ARCHIVE",
              lessor_s: "RETIRE"},
            "RCB"=>{
              offer_s: "RETIRE PAR LE BAILLEUR",
              lessor_s: "RETIRE"},
            "AIF"=>{
              offer_s: "EN ATTENTE COMMERCIALISATION",
              lessor_s: "EN ATTENTE PUBLICATION"},
            "INS"=>{
              offer_s: "EN COURS DE DESIGNATION",
              lessor_s: "EN DESIGNATION"},
            "REN"=>{
              offer_s: "RENDU AU BAILLEUR",
              lessor_s: "RENDU AU BAILLEUR CONFIRME"},
            "SGN"=>{
              offer_s: "LOGEMENT PLACE",
              lessor_s: "PLACE"},
            "TBA"=>{
              offer_s: "EN COURS D’ATTRIBUTION",
              lessor_s: "EN ATTRIBUTION"},
            }
  table = CSV.parse(File.read("Export_RBA_Supprime.csv"), headers: true, col_sep:  ";" )
  count = table.length

  table.each_with_index do |row, i|
    begin
      puts "#{i}/#{count}"

      old_offer_status = o.offer_status
      old_lessor_status = o.lessor_status

      o = Hermes::HousingOffer.find(row["REFALS"])

      action = "not good statuses"

      if o.lessor_status == "REPRISE BAILLEUR A CONFIRMER" && o.offer_status = "RETIRE PAR LE BAILLEUR"
        action = "mapping not found"
        if status = mapping[row["STATUS"]]
          o.offer_status = status[:offer_s]
          o.lessor_status = status[:lessor_s]
    
          # debut ligne à commenter pour mode sans modif
          o.set(
            updated_at: DateTime.now,
            offer_status: status[:offer_s],
            lessor_status: status[:lessor_s]
          )
          # fin ligne à commenter pour mode sans modif
          action = "udpated statuses"
        end 
      end
      line = [
        o.id,
        o.external_ref,
        o.als_id,
        old_offer_status,
        old_lessor_status,
        o.offer_status,
        o.lessor_status,
        action,
      ]

      file_log(file, line)

    rescue Exception => e
      line = [row["REFALS"], "Erreur de traitement: #{e}\n"]
      file_log(file, line)
    end
  end

  ##############################################################################
  ##############################################################################
  file.close
  stop_time = Time.now
  puts "Start end at #{stop_time}"
  puts "Executed in #{(stop_time - start_time).seconds}"
  puts "Filename: #{file_name}"
end
run_script(0)